# -*- coding: utf-8 -*-
# Generated by Django 1.10.5 on 2017-09-15 17:17
from __future__ import unicode_literals

import datetime
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='CoreObject',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=50)),
                ('description', models.CharField(blank=True, max_length=255)),
            ],
        ),
        migrations.CreateModel(
            name='History',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('text', models.CharField(max_length=255)),
                ('date', models.DateField(auto_now_add=True)),
            ],
        ),
        migrations.CreateModel(
            name='Note',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('text', models.CharField(max_length=255)),
                ('date', models.DateField(auto_now_add=True)),
                ('author', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Build',
            fields=[
                ('coreobject_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='projectcx.CoreObject')),
                ('number', models.IntegerField()),
                ('date', models.DateField(default=datetime.date(2017, 9, 15))),
            ],
            bases=('projectcx.coreobject',),
        ),
        migrations.CreateModel(
            name='Objective',
            fields=[
                ('coreobject_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='projectcx.CoreObject')),
                ('number', models.IntegerField()),
                ('type', models.CharField(choices=[('Feature', 'Feature'), ('Issue', 'Issue'), ('Bug', 'Bug')], default='Issue', max_length=10)),
                ('assigned_to', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            bases=('projectcx.coreobject',),
        ),
        migrations.CreateModel(
            name='Project',
            fields=[
                ('coreobject_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='projectcx.CoreObject')),
                ('prefix', models.CharField(max_length=10, unique=True)),
            ],
            bases=('projectcx.coreobject',),
        ),
        migrations.CreateModel(
            name='Release',
            fields=[
                ('coreobject_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='projectcx.CoreObject')),
                ('release_date', models.DateField(default=datetime.date(2017, 9, 15))),
                ('from_project', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='projectcx.Project')),
            ],
            bases=('projectcx.coreobject',),
        ),
        migrations.AddField(
            model_name='note',
            name='object',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='projectcx.CoreObject'),
        ),
        migrations.AddField(
            model_name='history',
            name='object',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='projectcx.CoreObject'),
        ),
        migrations.AddField(
            model_name='history',
            name='user',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='objective',
            name='from_project',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='projectcx.Project'),
        ),
        migrations.AddField(
            model_name='build',
            name='from_project',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='projectcx.Project'),
        ),
        migrations.AddField(
            model_name='build',
            name='from_release',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='projectcx.Release'),
        ),
    ]
