// Cerrax LiveEdit framework
// June 11, 2016
//--------------------------------
// Javascript client sends JSON info to server,
// which then updates the models and sends back a success or error.

// retreive the cookie for use with Django POST
function getCookie(name) {
    var cookieValue = null;
    if (document.cookie && document.cookie != '') {
        var cookies = document.cookie.split(';');
        for (var i = 0; i < cookies.length; i++) {
            var cookie = jQuery.trim(cookies[i]);
            // Does this cookie string begin with the name we want?
            if (cookie.substring(0, name.length + 1) == (name + '=')) {
                cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                break;
            }
        }
    }
    return cookieValue;
}
var csrftoken = getCookie('csrftoken');

$('.live-edit-error-box').hide();

var field_value;
var field_value_orig;
// store the field_value in the event of an error
// when an error occurs, re-populate the field with this value
$('.live-edit').focusin(function () {
	field_value = $(this).val();
	$(this).addClass('le-active');
})

// set all live-edit classed elements to execute the live edit when they lose focus
$('.live-edit').focusout(function() {
	obj = $(this)
	obj_id = $(this).attr('id');
	obj_value = $(this).val();
	execute_live_edit(obj_id, obj_value, obj);
	$(this).removeClass('le-active');
})

$('.onchange').change(function() {
	$(this).blur();
})
// set all live-edit classed elements to execute the live edit when the enter key is pressed and they are in focus
/* EDIT - REMOVED BECAUSE IT MAKES TEXT AREAS NOT CAPTURE THE ENTER KEY
$('.live-edit').keypress(function(event) {
	// check for ENTER key
	var code = (event.keyCode ? event.keyCode : event.which);
	if(code == 13) { //Enter keycode
		// trigger the release focus, which should trigger the live edit
		$(this).blur()
	}
})
*/

function execute_live_edit(obj_id, obj_value, obj) {
	var errorflag = false;
	console.log('LiveEdit request for ' + obj_id + ' with value: ' + obj_value);
	// parse the id of the element
	// modelid-modelname-fieldname
	var attributes = obj_id.split('-', 3);
	field_value_orig = field_value;
	var send_data = {
				'modelid': attributes[1],
				'modelname': attributes[0],
				'fieldname': attributes[2],
				'value': obj_value
			};
	// parse any required values needed
	if( obj.data('values') ){
		var required_data = JSON.stringify(obj.data('values'));
		send_data['req_vals'] = required_data;
	}
	// check if data has actually changed
	if( field_value_orig == obj_value) {
	 	// no change, exit before send
	 	console.log('no change!');
	 	return;
	}
	
	// send the ajax request
	$.ajax({
		async: false,
		url: live_edit_url,
		method: 'POST',
		headers: { "X-CSRFToken": csrftoken },
		//datatType: 'json',
		data: send_data,
		success: function(data, status, jqxhr) {
			errorflag = true;
			field_value = obj_value;
			$('.live-edit-error-box').hide();
		},
		error: function(jqxhr, status, errorText) {
			$('#'+obj_id).val(field_value_orig);
			errorflag = false;
			$('.live-edit-error-field').text(errorText);
			$('.live-edit-error-box').show();
		}
	});
	return errorflag;
}