$(document).ready( function() {

	$(".sortable").click(function() {run_sort(this, "asc");});

});

function run_sort(element, sort_type) {
	var column_header = $(element);
	var table_id = column_header.parents("table").attr("id");
	console.log(table_id);
	var index = column_header.index() + 1;
	var sort_table = []
	// drop each row into an array
	$("#"+table_id+" > tbody > tr").each( function() {
		var value = $(":nth-child("+index+")", this).text();
		sort_table.push({"value": value,"row":$(this)});
	});
	// sort the array
	var sort_func = window["default_sort"];
	if (column_header.data("sortby")) {
		sort_func = window[column_header.data("sortby")];
	}
	sort_table.sort(function(a, b) { return sort_func(a, b); } );
	//sort_table.sort(function(a, b) {return a["value"].localeCompare(b["value"]);} );
	if (sort_type == "desc") {
		sort_table.reverse();
	}
	// rebuild table from the array
	table_body = $("#"+table_id+" > tbody");
	table_body.empty();
	$.each(sort_table, function() {
		table_body.append(this["row"]);
	});
	// set the column_header class
	$("#"+table_id+" > thead > tr > th.sortable").removeClass("sorted-asc sorted-desc");
	$("#"+table_id+" > thead > tr > th.sortable").unbind().click(function() {run_sort(this, "asc");})
	column_header.addClass("sorted-"+sort_type);
	if (sort_type == "desc") {
		column_header.unbind().click(function() {run_sort(this, "asc");})
	}
	else {
		column_header.unbind().click(function() {run_sort(this, "desc");})
	}
	// attach behavior to table rows
	$('tr[data-href]').on("click", function() {
		document.location = $(this).data('href');
	});
}


function type_sort(a, b) {
	var priority_vals = {"Feature": 1, "Issue": 2, "Bug": 3};
	c = priority_vals[a["value"]];
	d = priority_vals[b["value"]];
	return c - d;
}

function status_sort(a, b) {
	var priority_vals = {"Open": 1, "In Development": 2, "In Testing": 3, "Closed": 4, "Deprecated": 5};
	c = priority_vals[a["value"]];
	d = priority_vals[b["value"]];
	return c - d;
}

function date_sort(a, b) {
	c = Date.parse(a["value"]);
	d = Date.parse(b["value"]);
	return c - d;
}

function number_sort(a, b) {
	c = parseInt(a["value"]);
	d = parseInt(b["value"]);
	return c - d;
}

function default_sort(a, b) {
	return a["value"].localeCompare(b["value"]);
}