from django.conf.urls import url

from projectcx import views

urlpatterns = [
	url(r'^liveedit/$', views.live_edit, name = 'live_edit'),
    url(r'^login/$', views.login_projectcx, name = 'login'),
    url(r'^logout/$', views.LogoutView.as_view(), name = 'logout'),
    url(r'^myobjectives/$', views.UserObjectives.as_view(), name = 'user_objectives'),

    url(r'^users/$', views.UserList.as_view(), name = 'user_list'),
    url(r'^users/create/$', views.UserCRUD.as_view(mode = 'create'), name = 'create_user'),
    url(r'^users/view/(?P<user_id>[0-9]+)/$', views.UserCRUD.as_view(mode = 'read'), name = 'read_user'),
    url(r'^users/update/(?P<user_id>[0-9]+)/$', views.UserCRUD.as_view(mode = 'update'), name = 'update_user'),
    url(r'^users/delete/(?P<user_id>[0-9]+)/$', views.UserCRUD.as_view(mode = 'delete'), name = 'delete_user'),

    url(r'^$', views.ProjectList.as_view(), name = 'project_list'),
    url(r'^projects/create/$', views.ProjectMainCRUD.as_view(mode = 'create'), name = 'create_project'),
    url(r'^projects/view/(?P<project_id>[0-9]+)/$', views.ProjectMainCRUD.as_view(mode = 'read'), name = 'read_project'),
    url(r'^projects/update/(?P<project_id>[0-9]+)/$', views.ProjectMainCRUD.as_view(mode = 'update'), name = 'update_project'),
    url(r'^projects/delete/(?P<project_id>[0-9]+)/$', views.ProjectMainCRUD.as_view(mode = 'delete'), name = 'delete_project'),

    url(r'^project/(?P<project_id>[0-9]+)/$', views.ProjectHome.as_view(), name = 'project_home'),
    url(r'^releases/(?P<project_id>[0-9]+)/$', views.Releases.as_view(), name = 'releases'),
    url(r'^features/(?P<project_id>[0-9]+)/$', views.Features.as_view(), name = 'features'),
    url(r'^issues/(?P<project_id>[0-9]+)/$', views.Issues.as_view(), name = 'issues'),
    url(r'^objectives/(?P<project_id>[0-9]+)/$', views.Objectives.as_view(), name = 'objectives'),

    url(r'^releases/(?P<project_id>[0-9]+)/create/$', views.ReleaseCRUD.as_view(mode = 'create'), name = 'create_release'),
    url(r'^releases/(?P<project_id>[0-9]+)/view/(?P<release_id>[0-9]+)/$', views.ReleaseCRUD.as_view(mode = 'read'), name = 'read_release'),
    url(r'^releases/(?P<project_id>[0-9]+)/update/(?P<release_id>[0-9]+)/$', views.ReleaseCRUD.as_view(mode = 'update'), name = 'update_release'),
    url(r'^releases/(?P<project_id>[0-9]+)/delete/(?P<release_id>[0-9]+)/$', views.ReleaseCRUD.as_view(mode = 'delete'), name = 'delete_release'),

    url(r'^builds/(?P<project_id>[0-9]+)/create/$', views.BuildCRUD.as_view(mode = 'create'), name = 'create_build'),
    url(r'^builds/(?P<project_id>[0-9]+)/view/(?P<build_id>[0-9]+)/$', views.BuildCRUD.as_view(mode = 'read'), name = 'read_build'),
    url(r'^builds/(?P<project_id>[0-9]+)/update/(?P<build_id>[0-9]+)/$', views.BuildCRUD.as_view(mode = 'update'), name = 'update_build'),
    url(r'^builds/(?P<project_id>[0-9]+)/delete/(?P<build_id>[0-9]+)/$', views.BuildCRUD.as_view(mode = 'delete'), name = 'delete_build'),

    url(r'^objectives/(?P<project_id>[0-9]+)/create/$', views.ObjectiveCRUD.as_view(mode = 'create'), name = 'create_objective'),
    url(r'^objectives/(?P<project_id>[0-9]+)/view/(?P<objective_id>[0-9]+)/$', views.ObjectiveCRUD.as_view(mode = 'read'), name = 'read_objective'),
    url(r'^objectives/(?P<project_id>[0-9]+)/update/(?P<objective_id>[0-9]+)/$', views.ObjectiveCRUD.as_view(mode = 'update'), name = 'update_objective'),
    url(r'^objectives/(?P<project_id>[0-9]+)/delete/(?P<objective_id>[0-9]+)/$', views.ObjectiveCRUD.as_view(mode = 'delete'), name = 'delete_objective'),

    url(r'^notes/(?P<project_id>[0-9]+)/create/$', views.create_note, name = 'create_note'),
]
